<%@LANGUAGE="VBScript"%>

<%
Dim objXML
Dim objXSL
Dim blnIsIE5

blnIsIE5 = False
strUA = Request.ServerVariables("HTTP_USER_AGENT")
If InStr(strUA, "MSIE") Then
  intVersion = CInt(Mid(strUA, InStr(strUA, "MSIE") + 5, 1))
  If intVersion > 4 Then blnIsIE5 = True  'this is IE5 or better
End If

If blnIsIE5 Then

  '***************************************
  'tell client that we're sending pure XML
  Response.ContentType = "text/xml"

  'create a parser instance
  Set objXML = Server.CreateObject("MSXML2.DOMDocument.3.0")

  'load the XML document
  objXML.load Server.MapPath("tables_data.xml")

  If objXML.parseError.errorCode = 0 Then

    'get a reference to the outermost <tables> element
    Set objOutermost = objXML.documentElement

    'create the processing instruction attributes
    QUOT = Chr(34)  'double-quote character
    strAttributes = "type=" & QUOT & "text/xsl" & QUOT _
      & " href=" & QUOT & "tables_style.xsl" & QUOT

    'create the new xsl-stylesheet processing instruction
    Set objNewPI = objXML.createProcessingInstruction("xml-stylesheet", strAttributes)

    'insert it into the XML document after the xml version element
    objXML.insertBefore objNewPI, objOutermost

    'and insert the results into the page
    Response.Write objXML.xml

  Else
    Response.Write "Error loading XML document."
  End If
  '***************************************

Else

  '***************************************
  'tell client that we're sending an HTML page
  Response.ContentType = "text/html"

  Sub ShowError(objDoc)
    'create and display error message
    Dim strError
    strError = "Invalid XML file !<BR />" _
             & "File URL: " & objDoc.parseError.url & "<BR />" _
             & "Line No.: " & objDoc.parseError.line & "<BR />" _
             & "Character: " & objDoc.parseError.linepos & "<BR />" _
             & "File Position: " & objDoc.parseError.filepos & "<BR />" _
             & "Source Text: " & objDoc.parseError.srcText & "<BR />" _
             & "Error Code: " & objDoc.parseError.errorCode & "<BR />" _
             & "Description: " & objDoc.parseError.reason
    Response.Write strError
  End Sub

  'create two parser instances
  Set objXML = Server.CreateObject("MSXML2.DOMDocument.3.0")
  Set objXSL = Server.CreateObject("MSXML2.DOMDocument.3.0")

  'set the parser properties
  objXML.ValidateOnParse = True
  objXSL.ValidateOnParse = True

  'load the XML document and check for errors
  objXML.load Server.MapPath("tables_data.xml")
  If objXML.parseError.errorCode <> 0 Then
    'error found so show error message and stop
    ShowError objXML
    Response.End
  End If

  'load the XSL stylesheet and check for errors
  objXSL.load Server.MapPath("tables_style.xsl")
  If objXSL.parseError.errorCode <> 0 Then
    'error found so show error message and stop
    ShowError objXSL
    Response.End
  End If

  'all must be OK, so perform transformation
  strResult = objXML.transformNode(objXSL)

  'and insert the results into the page
  Response.Write strResult
  '***************************************

End If
%>
