<xsl:transform
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 version="1.0"
>

<xsl:template match="sales">
<html><body>
   <h1>Product sales by period</h1>
   <xsl:variable name="cols" select="count(product[1]/period)"/>
   <table border="1" cellpadding="5" width="100%">
      <tr>
      <th width="50%">Product</th>
      <xsl:for-each select="product[1]/period">
         <th width="{round(50 div $cols)}%">
            <xsl:value-of select="@name"/>
         </th>
      </xsl:for-each>
   </tr>
   <xsl:for-each select="product">
   <tr>
      <td><xsl:value-of select="text()"/></td>
      <xsl:for-each select="period">
         <td>
            <xsl:value-of select="."/>
         </td>
      </xsl:for-each>
   </tr>
   </xsl:for-each>
   </table>
</body></html>
</xsl:template>

</xsl:transform>
