<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xslt"
                xmlns:redirect="org.apache.xalan.xslt.extensions.Redirect"
                extension-element-prefixes="redirect"
                version="1.0">
 
<xsl:template match="poem">
   <poem>
      <xsl:copy-of select="title"/>
      <xsl:copy-of select="author"/>
      <xsl:copy-of select="date"/>
      <xsl:apply-templates select="stanza"/>
   </poem>
</xsl:template>

<xsl:template match="stanza">
   <xsl:variable name="file" select="concat('verse', position(), '.xml')"/>
   <verse number="{position()}" href="{$file}"/> 
   <redirect:write select="$file">
        <xsl:copy-of select="."/> 
   </redirect:write>
</xsl:template>

</xsl:stylesheet>

